Subject: Re: [PATCH bpf-next V1] bpf: devmap dynamic map-value area based on BTF

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Fri, 05 Jun 2020 13:01:00 +0200

Jesper Dangaard Brouer <[email-masked]> writes:

> On Thu, 4 Jun 2020 10:33:41 -0700
> Alexei Starovoitov <[email-masked]> wrote:
>
>> On Thu, Jun 04, 2020 at 10:40:06AM -0600, David Ahern wrote:
>> > On 6/4/20 9:48 AM, Jesper Dangaard Brouer wrote:  
>> > > I will NOT send a patch that expose this in uapi/bpf.h.  As I explained
>> > > before, this caused the issues for my userspace application, that
>> > > automatically picked-up struct bpf_devmap_val, and started to fail
>> > > (with no code changes), because it needed minus-1 as input.  I fear
>> > > that this will cause more work for me later, when I have to helpout and
>> > > support end-users on e.g. xdp-newbies list, as it will not be obvious
>> > > to end-users why their programs map-insert start to fail.  I have given
>> > > up, so I will not NACK anyone sending such a patch.  
>> 
>> Jesper,
>> 
>> you gave wrong direction to David during development of the patches and
>> now the devmap uapi is suffering the consequences.
>> 
>> > > 
>> > > Why is it we need to support file-descriptor zero as a valid
>> > > file-descriptor for a bpf-prog?  
>> > 
>> > That was a nice property of using the id instead of fd. And the init to
>> > -1 is not unique to this; adopters of the bpf_set_link_xdp_fd_opts for
>> > example have to do the same.  
>> 
>> I think it's better to adopt "fd==0 -> invalid" approach.
>> It won't be unique here. We're already using it in other places in bpf syscall.
>> I agree with Jesper that requiring -1 init of 2nd field is quite ugly
>> and inconvenient.
>
> Great. If we can remove this requirement of -1 init (and let zero mean
> feature isn't used), then I'm all for exposing expose in uapi/bpf.h.

If we're going to officially deprecate fd 0 as a valid BPF fd, we should
at least make sure users don't end up with such an fd after opening a
BPF object. Not sure how the fd number assignment works, but could we
make sure that the kernel never returns fd 0 for a BPF program/map?

Alternatively, we could add a check in libbpf and either reject the
call, or just call dup() before passing the fd to the kernel.

Right now it's quite trivial to get a BPF program ref with fd0 - all you
have to do is open a BPF program is the first thing you do after closing
stdin (like a daemon might). I'd really rather not have to help anyone
debug that...

-Toke